<template>
  <div v-if="pageStatus == 0">配置加载中...</div>
  <div v-else-if="pageStatus == 1">此页面不对此账号开放</div>
  <div v-else-if="pageStatus == 2">没有此页内容的配置权限，请检查集团上的配置</div>
  <div v-else-if="pageStatus == 3">加载发生错误</div>
  <div v-else-if="pageStatus == 4" class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      label-width="68px"
    >
      <el-form-item style="float: right">
        <el-button
          type="cyan"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >刷新</el-button
        >
        <el-button icon="el-icon-plus" size="mini" @click="handleAdd"
          >新增</el-button
        >
      </el-form-item>
    </el-form>
    <el-table :data="gunList">
      <el-table-column width="55" align="center" />
      <el-table-column
        label="油枪主键自增id"
        v-if="false"
        align="center"
        prop="oilGunId"
      />
      <el-table-column label="油枪号" align="center" prop="oilGunNo" />
      <el-table-column label="油品名称" align="center" prop="oilName" />
      <el-table-column label="单价" align="center" prop="oilPrice" />
      <el-table-column
        label="油站id"
        align="center"
        prop="stationId"
        v-if="false"
      />
      <!--
      <el-table-column label="油站名称" align="center" prop="stationName" />
      -->
      <el-table-column label="操作时间" align="center" prop="date" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.date, "{y}-{m}-{d}") }}</span>
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 添加或修改油枪管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="90px">
        <el-form-item label="油枪号" prop="oilGunNo">
          <el-input
            v-model="form.oilGunNo"
            placeholder="请输入油枪号"
            style="width: 150px"
          />
        </el-form-item>
        <el-form-item label="油品名称" prop="oilName">
          <el-select
            v-model="form.oilName"
            placeholder="油品名称"
            clearable
            size="small"
            @change="onOilNameChang"
          >
            <el-option
              v-for="dict in oilNameOptions"
              :key="dict.oilName"
              :label="dict.oilName"
              :value="dict.oilName"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="单价" prop="oilPrice">
          {{ form.oilPrice === undefined ? "-------" : form.oilPrice + "元" }}
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listGun,
  getGun,
  delGun,
  addGun,
  updateGun,
  exportGun,
  stationinfo,
} from "@/api/station/gun";
import { listPrice, getPrice } from "@/api/station/price";
import { queryOilType } from "@/utils/oil";
export default {
  name: "Station_OilGun",
  data() {
    return {
      // 总条数
      total: 0,
      // 油枪管理表格数据
      gunList: [],
      oilNameOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      flage: true,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        stationId: this.deptId,
      },
      // 表单参数
      form: {},
      deptInfo: {},
      // 表单校验
      rules: {
        oilGunNo: [
          { required: true, message: "请输入油枪号", trigger: "blur" },
        ],
        oilName: [
          { required: true, message: "请选择油品名", trigger: "change" },
        ],
      },
      pageStatus: 0,
    };
  },
  created() {
    this.init();
    this.setPageStatus();
  },
  methods: {
    init() {
      this.getList();
      // 查询油品价格列表
      listPrice({
        stationId: this.deptId,
      }).then((response) => {
        this.oilNameOptions = response.rows;
      });
    },
    setPageStatus() {
      this.queryPageStatus([2]).then((res) => {
        this.pageStatus = res;
      });
    },
    /** 查询油枪管理列表 */
    getList() {
      listGun(this.queryParams).then((response) => {
        this.gunList = response.rows;
        this.total = response.total;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.title = "添加油枪";
      this.open = true;
      //【**】
      this.form = {
        stationId: this.deptId,
      };

      // this.form.stationName = this.deptInfo.deptName;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.title = "修改油枪";
      this.form = JSON.parse(JSON.stringify(row));
      this.open = true;
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.oilGunId != null) {
            updateGun(this.form).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addGun(this.form).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    onOilNameChang(oilName) {
      const oilOptions = this.oilNameOptions.find((ele) => {
        return ele.oilName == oilName;
      });
      if (oilOptions !== undefined) {
        this.form.oilPrice = oilOptions.oilPrice;
      }
      //【**】
      queryOilType(oilName).then((res) => {
        if (res == 3) {
          this.form.oilGunType = "2";
        } else {
          this.form.oilGunType = "1";
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const oilGunIds = row.oilGunId;
      this.$confirm("是否确认删除油枪", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delGun(oilGunIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有油枪管理数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return exportGun(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
        });
    },
  },
};
</script>
